Imports GrapeCity.ActiveReports
Imports GrapeCity.ActiveReports.Document
Imports System.Data
Imports System.Data.OleDb
Imports System.Data.SqlClient

Public Class LongRunningReport

    Private Sub detail_BeforePrint(sender As System.Object, e As System.EventArgs) Handles detail.BeforePrint
        If Me.detail.BackColor = Color.Gainsboro Then
            Me.detail.BackColor = Color.LightSteelBlue
        Else
            Me.detail.BackColor = Color.Gainsboro
        End If
    End Sub

    Public Function GetNoOfRecords(ds As Object) As Integer
        Dim noOfRecs As Integer = 0

        If ds.[GetType]().ToString() = "GrapeCity.ActiveReports.Data.SqlDBDataSource" Then
            Dim ods As GrapeCity.ActiveReports.Data.SqlDBDataSource = DirectCast(ds, GrapeCity.ActiveReports.Data.SqlDBDataSource)
            Dim con As New SqlConnection(ods.ConnectionString)
            Dim com As New SqlCommand("Select count(*) as totalRecs from (" + ods.SQL & ")", con)
            con.Open()
            Dim sdr As SqlDataReader = com.ExecuteReader()
            sdr.Read()
            If sdr.HasRows Then
                noOfRecs = Convert.ToInt32(sdr(0))
            End If
            con.Close()
        ElseIf ds.[GetType]().ToString() = "GrapeCity.ActiveReports.Data.OleDBDataSource" Then
            Dim ods As GrapeCity.ActiveReports.Data.OleDBDataSource = DirectCast(ds, GrapeCity.ActiveReports.Data.OleDBDataSource)
            Dim con As New OleDbConnection(ods.ConnectionString)
            Dim com As New OleDbCommand("Select count(*) as totalRecs from (" + ods.SQL & ")", con)
            con.Open()
            Dim odr As OleDbDataReader = com.ExecuteReader()
            odr.Read()
            If odr.HasRows Then
                noOfRecs = Convert.ToInt32(odr(0))
            End If
            con.Close()
        ElseIf ds.[GetType]().ToString() = "GrapeCity.ActiveReports.Data.XMLDataSource" Then
            Dim xds As GrapeCity.ActiveReports.Data.XMLDataSource = DirectCast(ds, GrapeCity.ActiveReports.Data.XMLDataSource)
            noOfRecs = xds.NodeList.Count
        ElseIf ds.[GetType]().ToString() = "System.Data.DataTable" Then
            Dim dtds As System.Data.DataTable = DirectCast(ds, System.Data.DataTable)
            noOfRecs = dtds.Rows.Count
        Else
            Dim lds As GrapeCity.ActiveReports.Data.ListDataSource = DirectCast(ds, GrapeCity.ActiveReports.Data.ListDataSource)
            noOfRecs = lds.List.Count
        End If
        Return noOfRecs
    End Function

End Class
